/*	traps_h.c.c

{{IS_NOTE

	Authors:	Tom M. Yeh
	Contributors:
	Create Date:	8/23/0 04:35PM
	$Header: /cvsroot/jedi/jdk/traps_h.c,v 1.4 2000/09/07 09:48:43 tomyeh Exp $
	Purpose:	Used to generate jdk/include/jdk/traps.h
	Description:
		See also jdk/Makefile
}}IS_NOTE

Copyright (C) 2000 Infoshock Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/

////////////////////////////////////////////////////////
typedef struct TAnakinApi {
#define _JDK_PRIME_
#include <anakin/_traps.h>
} TAnakinApi;

typedef struct TAnakinExApi {
#define _JDK_EXT_
#include <anakin/_traps.h>
} TAnakinExApi;

////////////////////////////////////////////////////////
_EXTERN_C_ const TAnakinApi* gJdk_pApi;
_EXTERN_C_ const TAnakinExApi* gJdk_pApiEx;
_EXTERN_C_ const char* gJdk_pPrcName;
	//we cannot use EXTERN_C since we want to preserve it to traps.h
	//by use of sed. See jdk/Makefile

+++#ifdef __cplusplus
extern "C" {
////////////////////////////////////////////////////////
#undef _TRAP
#define _TRAP(Func)	(gJdk_pApi->p##Func)
#define _JDK_API0(Rt, Fn)	inline Rt Fn(void) {return _TRAP(Fn)();}
#define _JDK_API1(Rt, Fn, A1)	inline Rt Fn(A1 a1) {return _TRAP(Fn)(a1);}
#define _JDK_API2(Rt, Fn, A1, A2)	inline Rt Fn(A1 a1, A2 a2) {return _TRAP(Fn)(a1, a2);}
#define _JDK_API3(Rt, Fn, A1, A2, A3)	inline Rt Fn(A1 a1, A2 a2, A3 a3) {return _TRAP(Fn)(a1, a2, a3);}
#define _JDK_API4(Rt, Fn, A1, A2, A3, A4)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4) {return _TRAP(Fn)(a1, a2, a3, a4);}
#define _JDK_API5(Rt, Fn, A1, A2, A3, A4, A5)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) {return _TRAP(Fn)(a1, a2, a3, a4, a5);}
#define _JDK_API6(Rt, Fn, A1, A2, A3, A4, A5, A6)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6);}
#define _JDK_API7(Rt, Fn, A1, A2, A3, A4, A5, A6, A7)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7);}
#define _JDK_API8(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8);}
#define _JDK_API9(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9);}
#define _JDK_API10(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);}
#define _JDK_API11(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);}
#define _JDK_API0_V(Fn)	inline void Fn(void) {_TRAP(Fn)();}
#define _JDK_API1_V(Fn, A1)	inline void Fn(A1 a1) {_TRAP(Fn)(a1);}
#define _JDK_API2_V(Fn, A1, A2)	inline void Fn(A1 a1, A2 a2) {_TRAP(Fn)(a1, a2);}
#define _JDK_API3_V(Fn, A1, A2, A3)	inline void Fn(A1 a1, A2 a2, A3 a3) {_TRAP(Fn)(a1, a2, a3);}
#define _JDK_API4_V(Fn, A1, A2, A3, A4)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4) {_TRAP(Fn)(a1, a2, a3, a4);}
#define _JDK_API5_V(Fn, A1, A2, A3, A4, A5)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) {_TRAP(Fn)(a1, a2, a3, a4, a5);}
#define _JDK_API6_V(Fn, A1, A2, A3, A4, A5, A6)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6);}
#define _JDK_API7_V(Fn, A1, A2, A3, A4, A5, A6, A7)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7);}
#define _JDK_API8_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8);}
#define _JDK_API9_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9);}
#define _JDK_API10_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);}
#define _JDK_API11_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);}

#define _JDK_PRIME_
#include <anakin/_traps.h>

#undef _TRAP
#define _TRAP(Func)	(gJdk_pApiEx->p##Func)
#define _JDK_API0(Rt, Fn)	inline Rt Fn(void) {return _TRAP(Fn)();}
#define _JDK_API1(Rt, Fn, A1)	inline Rt Fn(A1 a1) {return _TRAP(Fn)(a1);}
#define _JDK_API2(Rt, Fn, A1, A2)	inline Rt Fn(A1 a1, A2 a2) {return _TRAP(Fn)(a1, a2);}
#define _JDK_API3(Rt, Fn, A1, A2, A3)	inline Rt Fn(A1 a1, A2 a2, A3 a3) {return _TRAP(Fn)(a1, a2, a3);}
#define _JDK_API4(Rt, Fn, A1, A2, A3, A4)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4) {return _TRAP(Fn)(a1, a2, a3, a4);}
#define _JDK_API5(Rt, Fn, A1, A2, A3, A4, A5)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) {return _TRAP(Fn)(a1, a2, a3, a4, a5);}
#define _JDK_API6(Rt, Fn, A1, A2, A3, A4, A5, A6)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6);}
#define _JDK_API7(Rt, Fn, A1, A2, A3, A4, A5, A6, A7)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7);}
#define _JDK_API8(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8);}
#define _JDK_API9(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9);}
#define _JDK_API10(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);}
#define _JDK_API11(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)	inline Rt Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) {return _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);}
#define _JDK_API0_V(Fn)	inline void Fn(void) {_TRAP(Fn)();}
#define _JDK_API1_V(Fn, A1)	inline void Fn(A1 a1) {_TRAP(Fn)(a1);}
#define _JDK_API2_V(Fn, A1, A2)	inline void Fn(A1 a1, A2 a2) {_TRAP(Fn)(a1, a2);}
#define _JDK_API3_V(Fn, A1, A2, A3)	inline void Fn(A1 a1, A2 a2, A3 a3) {_TRAP(Fn)(a1, a2, a3);}
#define _JDK_API4_V(Fn, A1, A2, A3, A4)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4) {_TRAP(Fn)(a1, a2, a3, a4);}
#define _JDK_API5_V(Fn, A1, A2, A3, A4, A5)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) {_TRAP(Fn)(a1, a2, a3, a4, a5);}
#define _JDK_API6_V(Fn, A1, A2, A3, A4, A5, A6)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6);}
#define _JDK_API7_V(Fn, A1, A2, A3, A4, A5, A6, A7)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7);}
#define _JDK_API8_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8);}
#define _JDK_API9_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9);}
#define _JDK_API10_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);}
#define _JDK_API11_V(Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)	inline void Fn(A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) {_TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);}

#define _JDK_EXT_
#include <anakin/_traps.h>

} //extern "C"
+++#else //__cplusplus
////////////////////////////////////////////////////////
//Note: we cannot #define ... #define, so we use sed to do 
//further conversion. See jdk/Makefile
#undef _TRAP
#define _TRAP(Func)	(gJdk_pApi->p##Func)
#define _JDK_API0(Rt, Fn)	_Define_ Fn() _TRAP(Fn)()
#define _JDK_API1(Rt, Fn, A1)	_Define_ Fn(a1) _TRAP(Fn)(a1)
#define _JDK_API2(Rt, Fn, A1, A2)	_Define_ Fn(a1, a2) _TRAP(Fn)(a1, a2)
#define _JDK_API3(Rt, Fn, A1, A2, A3)	_Define_ Fn(a1, a2, a3) _TRAP(Fn)(a1, a2, a3)
#define _JDK_API4(Rt, Fn, A1, A2, A3, A4)	_Define_ Fn(a1, a2, a3, a4) _TRAP(Fn)(a1, a2, a3, a4)
#define _JDK_API5(Rt, Fn, A1, A2, A3, A4, A5)	_Define_ Fn(a1, a2, a3, a4, a5) _TRAP(Fn)(a1, a2, a3, a4, a5)
#define _JDK_API6(Rt, Fn, A1, A2, A3, A4, A5, A6)	_Define_ Fn(a1, a2, a3, a4, a5, a6) _TRAP(Fn)(a1, a2, a3, a4, a5, a6)
#define _JDK_API7(Rt, Fn, A1, A2, A3, A4, A5, A6, A7)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7)
#define _JDK_API8(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8)
#define _JDK_API9(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8, a9) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9)
#define _JDK_API10(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10)
#define _JDK_API11(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11)

#define _JDK_PRIME_
#include <anakin/_traps.h>

#undef _TRAP
#define _TRAP(Func)	(gJdk_pApiEx->p##Func)
#define _JDK_API0(Rt, Fn)	_Define_ Fn() _TRAP(Fn)()
#define _JDK_API1(Rt, Fn, A1)	_Define_ Fn(a1) _TRAP(Fn)(a1)
#define _JDK_API2(Rt, Fn, A1, A2)	_Define_ Fn(a1, a2) _TRAP(Fn)(a1, a2)
#define _JDK_API3(Rt, Fn, A1, A2, A3)	_Define_ Fn(a1, a2, a3) _TRAP(Fn)(a1, a2, a3)
#define _JDK_API4(Rt, Fn, A1, A2, A3, A4)	_Define_ Fn(a1, a2, a3, a4) _TRAP(Fn)(a1, a2, a3, a4)
#define _JDK_API5(Rt, Fn, A1, A2, A3, A4, A5)	_Define_ Fn(a1, a2, a3, a4, a5) _TRAP(Fn)(a1, a2, a3, a4, a5)
#define _JDK_API6(Rt, Fn, A1, A2, A3, A4, A5, A6)	_Define_ Fn(a1, a2, a3, a4, a5, a6) _TRAP(Fn)(a1, a2, a3, a4, a5, a6)
#define _JDK_API7(Rt, Fn, A1, A2, A3, A4, A5, A6, A7)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7)
#define _JDK_API8(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8)
#define _JDK_API9(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8, a9) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9)
#define _JDK_API10(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10)
#define _JDK_API11(Rt, Fn, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)	_Define_ Fn(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) _TRAP(Fn)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11)

#define _JDK_EXT_
#include <anakin/_traps.h>

+++#endif //__cplusplus
